"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useBaseQuery = void 0;
const vue_1 = require("vue");
const useQueryClient_1 = require("./useQueryClient");
function useBaseQuery(options, Observer) {
    const queryClient = useQueryClient_1.useQueryClient();
    const defaultedOptions = vue_1.computed(() => queryClient.defaultQueryObserverOptions(options));
    const observer = vue_1.computed(() => new Observer(queryClient, defaultedOptions.value));
    const state = vue_1.ref(observer.value.getCurrentResult());
    const unsubscribe = observer.value.subscribe((result) => {
        state.value = result;
    });
    vue_1.onUnmounted(() => {
        unsubscribe();
    });
    return vue_1.toRefs(vue_1.readonly(state));
}
exports.useBaseQuery = useBaseQuery;
