"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useQueries = void 0;
const core_1 = require("react-query/core");
const vue_1 = require("vue");
const useQueryClient_1 = require("./useQueryClient");
function useQueries(queries) {
    const queryClient = useQueryClient_1.useQueryClient();
    const observer = vue_1.computed(() => new core_1.QueriesObserver(queryClient, queries));
    if (observer.value.hasListeners()) {
        observer.value.setQueries(queries);
    }
    const state = vue_1.ref(observer.value.getCurrentResult());
    const unsubscribe = observer.value.subscribe((result) => {
        state.value = result;
    });
    vue_1.onUnmounted(() => {
        unsubscribe();
    });
    return vue_1.toRefs(vue_1.readonly(state));
}
exports.useQueries = useQueries;
